---
title: Release 2020-05-11
menuTitle: 2020-05-11
any: true
description: >-
  Changelog for Release 2020-05-11 (oso 0.0.3) containing new features, bug
  fixes, and more.
---

## `oso` 0.0.3

### Breaking changes

{{% callout "Warning" "orange" %}}
  This release contains breaking changes. Be sure to follow migration steps
  before upgrading.
{{% /callout %}}

#### Removed arguments to `@polar_class` decorator

The `oso.polar_class()` decorator no longer accepts `fields` or
`methods` arguments. Any field or method defined on the Application Class
will be accessible from Polar by default.

*Before:*

```python
@polar_class(fields=("id", "name", "specialty"), methods=("department", "hospital"))
class Doctor:
    ...
```

*After:*

```python
@polar_class
class Doctor:
    ...
```

#### Attempt to unify Python instances in Polar results in error

Fix for undefined behavior of application instance unification.
Now results in the following error message:

```console
PolarRuntimeException: Invalid operation: cannot unify Python instance objects.
```

*Before:*

```polar
allow(actor: User, action, resource) if
  actor = resource.owner();
```

Since `actor` is an instance of the `User` application class, any attempt
to unify `actor` (using the `=` operator) will result in a
`PolarRuntimeException`.

*After:*

The appropriate way to compare application instance objects is to use
field-by-field comparison.

```polar
allow(actor: User, action, resource) if
  actor.id = resource.owner().id;
```

### Other bugs & improvements

* Bug fix: Nested logical operators now evaluate appropriately.
